G_BEGIN_DECLS

typedef void (*emp_cli_channel_handler_callback_for_handle_channel) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_channel_handler_call_handle_channel (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    emp_cli_channel_handler_callback_for_handle_channel callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_channel_handler_run_handle_channel (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_debug_signal_callback_new_debug_message) (TpProxy *proxy,
    gdouble arg_time,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_debug_connect_to_new_debug_message (TpProxy *proxy,
    emp_cli_debug_signal_callback_new_debug_message callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_debug_callback_for_get_messages) (TpProxy *proxy,
    const GPtrArray *out_Messages,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_debug_call_get_messages (TpProxy *proxy,
    gint timeout_ms,
    emp_cli_debug_callback_for_get_messages callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_debug_run_get_messages (TpProxy *proxy,
    gint timeout_ms,
    GPtrArray **out_Messages,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_tube_handler_callback_for_handle_tube) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_tube_handler_call_handle_tube (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    emp_cli_tube_handler_callback_for_handle_tube callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_tube_handler_run_handle_tube (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    GError **error,
    GMainLoop **loop);


G_END_DECLS
