#include "_gen/svc-misc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _emp_svc_channel_handler_object_info;

struct _EmpSvcChannelHandlerClass {
    GTypeInterface parent_class;
    emp_svc_channel_handler_handle_channel_impl handle_channel;
};

static void emp_svc_channel_handler_base_init (gpointer klass);

GType
emp_svc_channel_handler_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcChannelHandlerClass),
        emp_svc_channel_handler_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcChannelHandler", &info, 0);
    }

  return type;
}

/**
 * emp_svc_channel_handler_handle_channel_impl:
 * @self: The object implementing this interface
 * @in_Bus_Name: const gchar * (FIXME, generate documentation)
 * @in_Connection: const gchar * (FIXME, generate documentation)
 * @in_Channel_Type: const gchar * (FIXME, generate documentation)
 * @in_Channel: const gchar * (FIXME, generate documentation)
 * @in_Handle_Type: guint  (FIXME, generate documentation)
 * @in_Handle: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * HandleChannel on interface org.freedesktop.Telepathy.ChannelHandler.
 */
static void
emp_svc_channel_handler_handle_channel (EmpSvcChannelHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context)
{
  emp_svc_channel_handler_handle_channel_impl impl = (EMP_SVC_CHANNEL_HANDLER_GET_CLASS (self)->handle_channel);

  if (impl != NULL)
    {
      (impl) (self,
        in_Bus_Name,
        in_Connection,
        in_Channel_Type,
        in_Channel,
        in_Handle_Type,
        in_Handle,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_channel_handler_implement_handle_channel:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the HandleChannel D-Bus method
 *
 * Register an implementation for the HandleChannel method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_channel_handler_implement_handle_channel (EmpSvcChannelHandlerClass *klass, emp_svc_channel_handler_handle_channel_impl impl)
{
  klass->handle_channel = impl;
}

static inline void
emp_svc_channel_handler_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.ChannelHandler");
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_CHANNEL_HANDLER, &interface);

  dbus_g_object_type_install_info (emp_svc_channel_handler_get_type (),
      &_emp_svc_channel_handler_object_info);
}
static void
emp_svc_channel_handler_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_channel_handler_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_channel_handler_methods[] = {
  { (GCallback) emp_svc_channel_handler_handle_channel, _emp_ext_marshal_VOID__STRING_BOXED_STRING_BOXED_UINT_UINT_POINTER, 0 },
};

static const DBusGObjectInfo _emp_svc_channel_handler_object_info = {
  0,
  _emp_svc_channel_handler_methods,
  1,
"org.freedesktop.Telepathy.ChannelHandler\0HandleChannel\0A\0Bus_Name\0I\0s\0Connection\0I\0o\0Channel_Type\0I\0s\0Channel\0I\0o\0Handle_Type\0I\0u\0Handle\0I\0u\0\0\0",
"\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_debug_object_info;

struct _EmpSvcDebugClass {
    GTypeInterface parent_class;
    emp_svc_debug_get_messages_impl get_messages;
};

enum {
    SIGNAL_DEBUG_NewDebugMessage,
    N_DEBUG_SIGNALS
};
static guint debug_signals[N_DEBUG_SIGNALS] = {0};

static void emp_svc_debug_base_init (gpointer klass);

GType
emp_svc_debug_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcDebugClass),
        emp_svc_debug_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcDebug", &info, 0);
    }

  return type;
}

/**
 * emp_svc_debug_get_messages_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetMessages on interface org.freedesktop.Telepathy.Debug.
 */
static void
emp_svc_debug_get_messages (EmpSvcDebug *self,
    DBusGMethodInvocation *context)
{
  emp_svc_debug_get_messages_impl impl = (EMP_SVC_DEBUG_GET_CLASS (self)->get_messages);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_debug_implement_get_messages:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetMessages D-Bus method
 *
 * Register an implementation for the GetMessages method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_debug_implement_get_messages (EmpSvcDebugClass *klass, emp_svc_debug_get_messages_impl impl)
{
  klass->get_messages = impl;
}

/**
 * emp_svc_debug_emit_new_debug_message:
 * @instance: The object implementing this interface
 * @arg_time: gdouble  (FIXME, generate documentation)
 * @arg_domain: const gchar * (FIXME, generate documentation)
 * @arg_level: guint  (FIXME, generate documentation)
 * @arg_message: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * NewDebugMessage signal on interface org.freedesktop.Telepathy.Debug.
 */
void
emp_svc_debug_emit_new_debug_message (gpointer instance,
    gdouble arg_time,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, EMP_TYPE_SVC_DEBUG));
  g_signal_emit (instance,
      debug_signals[SIGNAL_DEBUG_NewDebugMessage],
      0,
      arg_time,
      arg_domain,
      arg_level,
      arg_message);
}

static inline void
emp_svc_debug_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[2] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ | TP_DBUS_PROPERTIES_MIXIN_FLAG_WRITE, "b", 0, NULL, NULL }, /* Enabled */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Debug");
  properties[0].name = g_quark_from_static_string ("Enabled");
  properties[0].type = G_TYPE_BOOLEAN;
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_DEBUG, &interface);

  /**
   * EmpSvcDebug::new-debug-message:
   * @arg_time: gdouble  (FIXME, generate documentation)
   * @arg_domain: const gchar * (FIXME, generate documentation)
   * @arg_level: guint  (FIXME, generate documentation)
   * @arg_message: const gchar * (FIXME, generate documentation)
   *
   * The NewDebugMessage D-Bus signal is emitted whenever this GObject signal is.
   */
  debug_signals[SIGNAL_DEBUG_NewDebugMessage] =
  g_signal_new ("new-debug-message",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _emp_ext_marshal_VOID__DOUBLE_STRING_UINT_STRING,
      G_TYPE_NONE,
      4,
      G_TYPE_DOUBLE,
      G_TYPE_STRING,
      G_TYPE_UINT,
      G_TYPE_STRING);

  dbus_g_object_type_install_info (emp_svc_debug_get_type (),
      &_emp_svc_debug_object_info);
}
static void
emp_svc_debug_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_debug_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_debug_methods[] = {
  { (GCallback) emp_svc_debug_get_messages, g_cclosure_marshal_VOID__POINTER, 0 },
};

static const DBusGObjectInfo _emp_svc_debug_object_info = {
  0,
  _emp_svc_debug_methods,
  1,
"org.freedesktop.Telepathy.Debug\0GetMessages\0A\0Messages\0O\0F\0N\0a(dsus)\0\0\0",
"org.freedesktop.Telepathy.Debug\0NewDebugMessage\0\0",
"\0\0",
};

static const DBusGObjectInfo _emp_svc_tube_handler_object_info;

struct _EmpSvcTubeHandlerClass {
    GTypeInterface parent_class;
    emp_svc_tube_handler_handle_tube_impl handle_tube;
};

static void emp_svc_tube_handler_base_init (gpointer klass);

GType
emp_svc_tube_handler_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (EmpSvcTubeHandlerClass),
        emp_svc_tube_handler_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "EmpSvcTubeHandler", &info, 0);
    }

  return type;
}

/**
 * emp_svc_tube_handler_handle_tube_impl:
 * @self: The object implementing this interface
 * @in_Bus_Name: const gchar * (FIXME, generate documentation)
 * @in_Connection: const gchar * (FIXME, generate documentation)
 * @in_Channel: const gchar * (FIXME, generate documentation)
 * @in_Handle_Type: guint  (FIXME, generate documentation)
 * @in_Handle: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * HandleTube on interface org.gnome.Empathy.TubeHandler.
 */
static void
emp_svc_tube_handler_handle_tube (EmpSvcTubeHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context)
{
  emp_svc_tube_handler_handle_tube_impl impl = (EMP_SVC_TUBE_HANDLER_GET_CLASS (self)->handle_tube);

  if (impl != NULL)
    {
      (impl) (self,
        in_Bus_Name,
        in_Connection,
        in_Channel,
        in_Handle_Type,
        in_Handle,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * emp_svc_tube_handler_implement_handle_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the HandleTube D-Bus method
 *
 * Register an implementation for the HandleTube method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
emp_svc_tube_handler_implement_handle_tube (EmpSvcTubeHandlerClass *klass, emp_svc_tube_handler_handle_tube_impl impl)
{
  klass->handle_tube = impl;
}

static inline void
emp_svc_tube_handler_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.gnome.Empathy.TubeHandler");
  tp_svc_interface_set_dbus_properties_info (EMP_TYPE_SVC_TUBE_HANDLER, &interface);

  dbus_g_object_type_install_info (emp_svc_tube_handler_get_type (),
      &_emp_svc_tube_handler_object_info);
}
static void
emp_svc_tube_handler_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      emp_svc_tube_handler_base_init_once (klass);
    }
}
static const DBusGMethodInfo _emp_svc_tube_handler_methods[] = {
  { (GCallback) emp_svc_tube_handler_handle_tube, _emp_ext_marshal_VOID__STRING_BOXED_BOXED_UINT_UINT_POINTER, 0 },
};

static const DBusGObjectInfo _emp_svc_tube_handler_object_info = {
  0,
  _emp_svc_tube_handler_methods,
  1,
"org.gnome.Empathy.TubeHandler\0HandleTube\0A\0Bus_Name\0I\0s\0Connection\0I\0o\0Channel\0I\0o\0Handle_Type\0I\0u\0Handle\0I\0u\0\0\0",
"\0\0",
"\0\0",
};


