#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * EmpSvcChannelHandler:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcChannelHandler EmpSvcChannelHandler;

/**
 * EmpSvcChannelHandlerClass:
 *
 * The class of EmpSvcChannelHandler.
 */
typedef struct _EmpSvcChannelHandlerClass EmpSvcChannelHandlerClass;

GType emp_svc_channel_handler_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_HANDLER \
  (emp_svc_channel_handler_get_type ())
#define EMP_SVC_CHANNEL_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_HANDLER, EmpSvcChannelHandler))
#define EMP_IS_SVC_CHANNEL_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_HANDLER))
#define EMP_SVC_CHANNEL_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_HANDLER, EmpSvcChannelHandlerClass))


typedef void (*emp_svc_channel_handler_handle_channel_impl) (EmpSvcChannelHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel_Type,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context);
void emp_svc_channel_handler_implement_handle_channel (EmpSvcChannelHandlerClass *klass, emp_svc_channel_handler_handle_channel_impl impl);
/**
 * emp_svc_channel_handler_return_from_handle_channel:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_handler_return_from_handle_channel (DBusGMethodInvocation *context);
static inline void
emp_svc_channel_handler_return_from_handle_channel (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}


/**
 * EmpSvcDebug:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcDebug EmpSvcDebug;

/**
 * EmpSvcDebugClass:
 *
 * The class of EmpSvcDebug.
 */
typedef struct _EmpSvcDebugClass EmpSvcDebugClass;

GType emp_svc_debug_get_type (void);
#define EMP_TYPE_SVC_DEBUG \
  (emp_svc_debug_get_type ())
#define EMP_SVC_DEBUG(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_DEBUG, EmpSvcDebug))
#define EMP_IS_SVC_DEBUG(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_DEBUG))
#define EMP_SVC_DEBUG_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_DEBUG, EmpSvcDebugClass))


typedef void (*emp_svc_debug_get_messages_impl) (EmpSvcDebug *self,
    DBusGMethodInvocation *context);
void emp_svc_debug_implement_get_messages (EmpSvcDebugClass *klass, emp_svc_debug_get_messages_impl impl);
/**
 * emp_svc_debug_return_from_get_messages:
 * @context: The D-Bus method invocation context
 * @out_Messages: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_debug_return_from_get_messages (DBusGMethodInvocation *context,
    const GPtrArray *out_Messages);
static inline void
emp_svc_debug_return_from_get_messages (DBusGMethodInvocation *context,
    const GPtrArray *out_Messages)
{
  dbus_g_method_return (context,
      out_Messages);
}

void emp_svc_debug_emit_new_debug_message (gpointer instance,
    gdouble arg_time,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message);

/**
 * EmpSvcTubeHandler:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _EmpSvcTubeHandler EmpSvcTubeHandler;

/**
 * EmpSvcTubeHandlerClass:
 *
 * The class of EmpSvcTubeHandler.
 */
typedef struct _EmpSvcTubeHandlerClass EmpSvcTubeHandlerClass;

GType emp_svc_tube_handler_get_type (void);
#define EMP_TYPE_SVC_TUBE_HANDLER \
  (emp_svc_tube_handler_get_type ())
#define EMP_SVC_TUBE_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_TUBE_HANDLER, EmpSvcTubeHandler))
#define EMP_IS_SVC_TUBE_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_TUBE_HANDLER))
#define EMP_SVC_TUBE_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_TUBE_HANDLER, EmpSvcTubeHandlerClass))


typedef void (*emp_svc_tube_handler_handle_tube_impl) (EmpSvcTubeHandler *self,
    const gchar *in_Bus_Name,
    const gchar *in_Connection,
    const gchar *in_Channel,
    guint in_Handle_Type,
    guint in_Handle,
    DBusGMethodInvocation *context);
void emp_svc_tube_handler_implement_handle_tube (EmpSvcTubeHandlerClass *klass, emp_svc_tube_handler_handle_tube_impl impl);
/**
 * emp_svc_tube_handler_return_from_handle_tube:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_tube_handler_return_from_handle_tube (DBusGMethodInvocation *context);
static inline void
emp_svc_tube_handler_return_from_handle_tube (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}



G_END_DECLS
